"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateUpdatedHandler = void 0;
const cqrs_1 = require("@nestjs/cqrs");
const transaction_poll_service_1 = require("./transaction-poll.service");
const issuer_api_1 = require("@energyweb/issuer-api");
let CertificateUpdatedHandler = class CertificateUpdatedHandler {
    constructor(transactionPoll) {
        this.transactionPoll = transactionPoll;
    }
    async handle(event) {
        const txHash = event.byTxHash;
        if (txHash) {
            await this.transactionPoll.saveTransactionAsProcessed(txHash);
        }
    }
};
CertificateUpdatedHandler = __decorate([
    cqrs_1.EventsHandler(issuer_api_1.CertificateUpdatedEvent),
    __metadata("design:paramtypes", [transaction_poll_service_1.TransactionPollService])
], CertificateUpdatedHandler);
exports.CertificateUpdatedHandler = CertificateUpdatedHandler;
//# sourceMappingURL=certificate-updated.handler.js.map