"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateModule = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const bull_1 = require("@nestjs/bull");
const issuer_api_1 = require("@energyweb/issuer-api");
const transaction_poll_service_1 = require("./transaction-poll.service");
const certificate_service_1 = require("./certificate.service");
const blockchain_actions_processor_1 = require("./blockchain-actions.processor");
const types_1 = require("./types");
const certificate_updated_handler_1 = require("./certificate-updated.handler");
const serviceProvider = {
    provide: types_1.CERTIFICATE_SERVICE_TOKEN,
    useClass: certificate_service_1.CertificateService
};
let CertificateModule = class CertificateModule {
};
CertificateModule = __decorate([
    common_1.Module({
        providers: [
            serviceProvider,
            blockchain_actions_processor_1.BlockchainActionsProcessor,
            transaction_poll_service_1.TransactionPollService,
            certificate_updated_handler_1.CertificateUpdatedHandler
        ],
        exports: [serviceProvider],
        imports: [
            issuer_api_1.IssuerModule.register({
                enableCertificationRequest: false,
                enableTransactionLogging: true
            }),
            cqrs_1.CqrsModule,
            bull_1.BullModule.registerQueue({
                name: 'blockchain-actions',
                settings: {
                    lockDuration: Number(process.env.CERTIFICATE_QUEUE_LOCK_DURATION ?? 240 * 1000)
                }
            })
        ]
    })
], CertificateModule);
exports.CertificateModule = CertificateModule;
//# sourceMappingURL=certificate.module.js.map