import { CertificateService } from './certificate.service';
import { IGetAllCertificatesOptions } from '@energyweb/issuer-api';
import { ICertificate, IClaimCommand, ITransferCommand, ISuccessResponse, IIssuedCertificate, IIssueCommandParams } from './types';
declare type PublicPart<T> = {
    [K in keyof T]: T[K];
};
export declare class CertificateForUnitTestsService<T> implements PublicPart<CertificateService<T>> {
    private serial;
    private db;
    getAll(options?: IGetAllCertificatesOptions): Promise<ICertificate<T>[]>;
    getById(id: number): Promise<ICertificate<T> | null>;
    issue(params: IIssueCommandParams<T>): Promise<IIssuedCertificate<T>>;
    claim(command: IClaimCommand): Promise<ISuccessResponse>;
    transfer(command: ITransferCommand): Promise<ISuccessResponse>;
    batchIssue(originalCertificates: IIssueCommandParams<T>[]): Promise<number[]>;
    batchClaim(command: IClaimCommand[]): Promise<ISuccessResponse>;
    batchTransfer(command: ITransferCommand[]): Promise<ISuccessResponse>;
}
export {};
