export declare namespace CertificateErrors {
    namespace Issuance {
        class CertificateAlreadyIssued extends Error {
            constructor(internalCertificateId: number);
        }
    }
    namespace Transfer {
        class CertificateNotIssued extends Error {
            constructor(internalCertificateId: number);
        }
        class FromZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class ToZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class NotEnoughBalance extends Error {
            constructor(internalCertificateId: any, address: any);
        }
    }
    namespace Claim {
        class CertificateNotIssued extends Error {
            constructor(internalCertificateId: number);
        }
        class ForZeroAddress extends Error {
            constructor(internalCertificateId: number);
        }
        class NotEnoughBalance extends Error {
            constructor(internalCertificateId: any, address: any);
        }
    }
    class BatchError extends Error {
        constructor(originError: Error);
    }
}
