"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificatePersistErrorEvent = exports.CertificateClaimPersistedEvent = exports.CertificateTransferPersistedEvent = exports.CertificateIssuancePersistedEvent = exports.CertificateClaimedEvent = exports.CertificateTransferredEvent = exports.CertificateIssuedEvent = exports.CertificateEventType = void 0;
const version = 1;
var CertificateEventType;
(function (CertificateEventType) {
    CertificateEventType["Issued"] = "Issued";
    CertificateEventType["Transferred"] = "Transferred";
    CertificateEventType["Claimed"] = "Claimed";
    CertificateEventType["IssuancePersisted"] = "IssuancePersisted";
    CertificateEventType["TransferPersisted"] = "TransferPersisted";
    CertificateEventType["ClaimPersisted"] = "ClaimPersisted";
    CertificateEventType["PersistError"] = "PersistError";
})(CertificateEventType = exports.CertificateEventType || (exports.CertificateEventType = {}));
class CertificateIssuedEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.Issued;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateIssuedEvent = CertificateIssuedEvent;
class CertificateTransferredEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.Transferred;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateTransferredEvent = CertificateTransferredEvent;
class CertificateClaimedEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.Claimed;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateClaimedEvent = CertificateClaimedEvent;
class CertificateIssuancePersistedEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.IssuancePersisted;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateIssuancePersistedEvent = CertificateIssuancePersistedEvent;
class CertificateTransferPersistedEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.TransferPersisted;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateTransferPersistedEvent = CertificateTransferPersistedEvent;
class CertificateClaimPersistedEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.ClaimPersisted;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificateClaimPersistedEvent = CertificateClaimPersistedEvent;
class CertificatePersistErrorEvent {
    constructor(internalCertificateId, payload) {
        this.internalCertificateId = internalCertificateId;
        this.payload = payload;
        this.type = CertificateEventType.PersistError;
        this.version = version;
        this.createdAt = new Date();
    }
}
exports.CertificatePersistErrorEvent = CertificatePersistErrorEvent;
//# sourceMappingURL=Certificate.events.js.map