"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OffChainCertificateForUnitTestsModule = exports.OffChainCertificateModule = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const CertificateCommandPostgres_repository_1 = require("./repositories/CertificateCommand/CertificateCommandPostgres.repository");
const CertificateEventPostgres_repository_1 = require("./repositories/CertificateEvent/CertificateEventPostgres.repository");
const offchain_certificate_service_1 = require("./offchain-certificate.service");
const typeorm_1 = require("@nestjs/typeorm");
const CertificateCommand_entity_1 = require("./repositories/CertificateCommand/CertificateCommand.entity");
const CertificateEvent_entity_1 = require("./repositories/CertificateEvent/CertificateEvent.entity");
const CertificateReadModel_entity_1 = require("./repositories/CertificateReadModel/CertificateReadModel.entity");
const CertificateReadModelPostgres_repository_1 = require("./repositories/CertificateReadModel/CertificateReadModelPostgres.repository");
const bull_1 = require("@nestjs/bull");
const blockchain_synchronize_service_1 = require("./synchronize/blockchain-synchronize.service");
const blockchain_synchronize_task_1 = require("./synchronize/blockchain-synchronize.task");
const synchronize_strategy_1 = require("./synchronize/strategies/synchronize.strategy");
const repository_keys_1 = require("./repositories/repository.keys");
const claim_persist_handler_1 = require("./synchronize/handlers/claim-persist.handler");
const transfer_persist_handler_1 = require("./synchronize/handlers/transfer-persist.handler");
const onchain_certificate_module_1 = require("../onchain-certificate/onchain-certificate.module");
const CertificateSynchronizationAttempt_entity_1 = require("./repositories/CertificateEvent/CertificateSynchronizationAttempt.entity");
const CertificateEvent_service_1 = require("./repositories/CertificateEvent/CertificateEvent.service");
const batch_synchronize_strategy_1 = require("./synchronize/strategies/batch/batch-synchronize.strategy");
const batch_configuration_1 = require("./synchronize/strategies/batch/batch.configuration");
const issue_persist_handler_1 = require("./synchronize/handlers/issue-persist.handler");
const synchronize_manager_1 = require("./synchronize/handlers/synchronize.manager");
const CertificateCommandInMemory_repository_1 = require("./repositories/CertificateCommand/CertificateCommandInMemory.repository");
const CertificateEventInMemory_repository_1 = require("./repositories/CertificateEvent/CertificateEventInMemory.repository");
const CertificateReadModelInMemory_repository_1 = require("./repositories/CertificateReadModel/CertificateReadModelInMemory.repository");
let OffChainCertificateModule = class OffChainCertificateModule {
};
OffChainCertificateModule = __decorate([
    common_1.Module({
        providers: [
            {
                provide: repository_keys_1.CERTIFICATE_COMMAND_REPOSITORY,
                useClass: CertificateCommandPostgres_repository_1.CertificateCommandPostgresRepository
            },
            {
                provide: repository_keys_1.CERTIFICATE_EVENT_REPOSITORY,
                useClass: CertificateEventPostgres_repository_1.CertificateEventPostgresRepository
            },
            {
                provide: repository_keys_1.CERTIFICATE_READ_MODEL_REPOSITORY,
                useClass: CertificateReadModelPostgres_repository_1.CertificateReadModelPostgresRepository
            },
            {
                provide: synchronize_strategy_1.SYNCHRONIZE_STRATEGY,
                useClass: batch_synchronize_strategy_1.BatchSynchronizeStrategy
            },
            {
                provide: batch_configuration_1.BATCH_CONFIGURATION_TOKEN,
                useValue: batch_configuration_1.batchConfiguration
            },
            offchain_certificate_service_1.OffChainCertificateService,
            blockchain_synchronize_service_1.BlockchainSynchronizeService,
            blockchain_synchronize_task_1.BlockchainSynchronizeTask,
            issue_persist_handler_1.IssuePersistHandler,
            claim_persist_handler_1.ClaimPersistHandler,
            transfer_persist_handler_1.TransferPersistHandler,
            synchronize_manager_1.SynchronizeManager,
            CertificateEvent_service_1.CertificateEventService
        ],
        exports: [offchain_certificate_service_1.OffChainCertificateService],
        imports: [
            onchain_certificate_module_1.OnChainCertificateModule,
            cqrs_1.CqrsModule,
            typeorm_1.TypeOrmModule.forFeature([
                CertificateEvent_entity_1.CertificateEventEntity,
                CertificateCommand_entity_1.CertificateCommandEntity,
                CertificateReadModel_entity_1.CertificateReadModelEntity,
                CertificateSynchronizationAttempt_entity_1.CertificateSynchronizationAttemptEntity
            ]),
            bull_1.BullModule.registerQueue({
                name: repository_keys_1.SYNCHRONIZE_QUEUE_NAME
            })
        ]
    })
], OffChainCertificateModule);
exports.OffChainCertificateModule = OffChainCertificateModule;
let OffChainCertificateForUnitTestsModule = class OffChainCertificateForUnitTestsModule {
};
OffChainCertificateForUnitTestsModule = __decorate([
    common_1.Module({
        providers: [
            {
                provide: repository_keys_1.CERTIFICATE_COMMAND_REPOSITORY,
                useClass: CertificateCommandInMemory_repository_1.CertificateCommandInMemoryRepository
            },
            {
                provide: repository_keys_1.CERTIFICATE_EVENT_REPOSITORY,
                useClass: CertificateEventInMemory_repository_1.CertificateEventInMemoryRepository
            },
            {
                provide: repository_keys_1.CERTIFICATE_READ_MODEL_REPOSITORY,
                useClass: CertificateReadModelInMemory_repository_1.CertificateReadModelInMemoryRepository
            },
            {
                provide: synchronize_strategy_1.SYNCHRONIZE_STRATEGY,
                useClass: batch_synchronize_strategy_1.BatchSynchronizeStrategy
            },
            {
                provide: batch_configuration_1.BATCH_CONFIGURATION_TOKEN,
                useValue: batch_configuration_1.batchConfiguration
            },
            offchain_certificate_service_1.OffChainCertificateService,
            blockchain_synchronize_service_1.BlockchainSynchronizeService,
            blockchain_synchronize_task_1.BlockchainSynchronizeTask,
            issue_persist_handler_1.IssuePersistHandler,
            claim_persist_handler_1.ClaimPersistHandler,
            transfer_persist_handler_1.TransferPersistHandler,
            synchronize_manager_1.SynchronizeManager,
            CertificateEvent_service_1.CertificateEventService
        ],
        exports: [offchain_certificate_service_1.OffChainCertificateService],
        imports: [onchain_certificate_module_1.OnChainCertificateForUnitTestsModule, cqrs_1.CqrsModule]
    })
], OffChainCertificateForUnitTestsModule);
exports.OffChainCertificateForUnitTestsModule = OffChainCertificateForUnitTestsModule;
//# sourceMappingURL=offchain-certificate.module.js.map