"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateEventService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const Certificate_events_1 = require("../../events/Certificate.events");
const CertificateSynchronizationAttempt_entity_1 = require("./CertificateSynchronizationAttempt.entity");
const repository_keys_1 = require("../repository.keys");
let CertificateEventService = class CertificateEventService {
    constructor(certificateEventRepository, entityManager) {
        this.certificateEventRepository = certificateEventRepository;
        this.entityManager = entityManager;
    }
    async save(event, commandId) {
        return await this.entityManager.transaction(async (txManager) => {
            const savedEvent = await this.certificateEventRepository.save({
                internalCertificateId: event.internalCertificateId,
                type: event.type,
                version: event.version,
                payload: event.payload,
                createdAt: event.createdAt
            }, commandId, txManager);
            if (this.shouldBeSynchronized(savedEvent)) {
                const syncRepository = txManager.getRepository(CertificateSynchronizationAttempt_entity_1.CertificateSynchronizationAttemptEntity);
                const synchronizationEntity = syncRepository.create({
                    attemptsCount: 0,
                    eventId: savedEvent.id
                });
                await syncRepository.save(synchronizationEntity);
            }
            return savedEvent;
        });
    }
    shouldBeSynchronized(event) {
        const synchronizableEventTypes = [
            Certificate_events_1.CertificateEventType.Issued,
            Certificate_events_1.CertificateEventType.Claimed,
            Certificate_events_1.CertificateEventType.Transferred
        ];
        return synchronizableEventTypes.includes(event.type);
    }
};
CertificateEventService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(repository_keys_1.CERTIFICATE_EVENT_REPOSITORY)),
    __metadata("design:paramtypes", [Object, typeorm_1.EntityManager])
], CertificateEventService);
exports.CertificateEventService = CertificateEventService;
//# sourceMappingURL=CertificateEvent.service.js.map