import { Repository } from 'typeorm';
import { CertificateEventEntity } from './CertificateEvent.entity';
import { CertificateEventRepository, SynchronizableEvent } from './CertificateEvent.repository';
import { ICertificateEvent } from '../../events/Certificate.events';
import { CertificateSynchronizationAttemptEntity } from './CertificateSynchronizationAttempt.entity';
export declare class CertificateEventPostgresRepository implements CertificateEventRepository {
    private repository;
    private synchronizationAttemptRepository;
    constructor(repository: Repository<CertificateEventEntity>, synchronizationAttemptRepository: Repository<CertificateSynchronizationAttemptEntity>);
    getAll(): Promise<CertificateEventEntity[]>;
    getByInternalCertificateId(internalCertId: number): Promise<CertificateEventEntity[]>;
    save(event: ICertificateEvent, commandId: number, txManager: any): Promise<CertificateEventEntity>;
    updateAttempt({ eventId, error }: {
        eventId: any;
        error: any;
    }): Promise<CertificateSynchronizationAttemptEntity>;
    getAllNotProcessed(): Promise<SynchronizableEvent[]>;
    getOne(eventId: number): Promise<CertificateEventEntity>;
    getNumberOfCertificates(): Promise<number>;
}
