"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateReadModelInMemoryRepository = void 0;
const common_1 = require("@nestjs/common");
let CertificateReadModelInMemoryRepository = class CertificateReadModelInMemoryRepository {
    constructor() {
        this.db = [];
    }
    async save(certificateReadModel) {
        this.db.push(certificateReadModel);
        return certificateReadModel;
    }
    async getByInternalCertificateId(internalCertificateId) {
        const found = await this.db.find((e) => e.internalCertificateId === internalCertificateId);
        return found ?? null;
    }
    async getManyByInternalCertificateIds(internalCertificateIds) {
        return this.db.filter((e) => internalCertificateIds.includes(e.internalCertificateId));
    }
    async getAll(options = {}) {
        const lastDate = new Date('2030-01-01T00:00:00.000Z');
        const generationEndFrom = options.generationEndFrom ?? new Date(0);
        const generationEndTo = options.generationEndTo ?? lastDate;
        const generationStartFrom = options.generationStartFrom ?? new Date(0);
        const generationStartTo = options.generationStartTo ?? lastDate;
        const creationTimeFrom = options.creationTimeFrom ?? new Date(0);
        const creationTimeTo = options.creationTimeTo ?? lastDate;
        const deviceId = options.deviceId;
        return this.db.filter((entry) => {
            const isDateOk = new Date(entry.generationStartTime * 1000) >= generationStartFrom &&
                new Date(entry.generationStartTime * 1000) <= generationStartTo &&
                new Date(entry.generationEndTime * 1000) >= generationEndFrom &&
                new Date(entry.generationEndTime * 1000) <= generationEndTo &&
                new Date(entry.creationTime * 1000) >= creationTimeFrom &&
                new Date(entry.creationTime * 1000) <= creationTimeTo;
            const isDeviceOk = deviceId ? deviceId === entry.deviceId : true;
            return isDateOk && isDeviceOk;
        });
    }
};
CertificateReadModelInMemoryRepository = __decorate([
    common_1.Injectable()
], CertificateReadModelInMemoryRepository);
exports.CertificateReadModelInMemoryRepository = CertificateReadModelInMemoryRepository;
//# sourceMappingURL=CertificateReadModelInMemory.repository.js.map