"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificateReadModelPostgresRepository = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const CertificateReadModel_entity_1 = require("./CertificateReadModel.entity");
const dateToSeconds = (d) => Math.floor(d.getTime() / 1000);
const futureDate = new Date('2038-01-01T00:00:00.000Z');
let CertificateReadModelPostgresRepository = class CertificateReadModelPostgresRepository {
    constructor(repository) {
        this.repository = repository;
    }
    async save(certificateReadModel) {
        await this.repository.save(certificateReadModel);
        return certificateReadModel;
    }
    async getAll(options = {}) {
        const generationEndFrom = dateToSeconds(options.generationEndFrom ?? new Date(0));
        const generationEndTo = dateToSeconds(options.generationEndTo ?? futureDate);
        const generationStartFrom = dateToSeconds(options.generationStartFrom ?? new Date(0));
        const generationStartTo = dateToSeconds(options.generationStartTo ?? futureDate);
        const creationTimeFrom = dateToSeconds(options.creationTimeFrom ?? new Date(0));
        const creationTimeTo = dateToSeconds(options.creationTimeTo ?? futureDate);
        return this.repository.find({
            where: {
                generationEndTime: typeorm_2.Between(generationEndFrom, generationEndTo),
                generationStartTime: typeorm_2.Between(generationStartFrom, generationStartTo),
                creationTime: typeorm_2.Between(creationTimeFrom, creationTimeTo),
                ...(options.deviceId ? { deviceId: options.deviceId } : {})
            },
            order: {
                internalCertificateId: 'ASC'
            }
        });
    }
    async getByInternalCertificateId(internalCertificateId) {
        const found = await this.repository.findOne({
            where: {
                internalCertificateId: internalCertificateId
            }
        });
        return found ?? null;
    }
    async getManyByInternalCertificateIds(internalCertificateIds) {
        return await this.repository.find({
            where: {
                internalCertificateId: typeorm_2.In(internalCertificateIds)
            }
        });
    }
};
CertificateReadModelPostgresRepository = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(CertificateReadModel_entity_1.CertificateReadModelEntity)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], CertificateReadModelPostgresRepository);
exports.CertificateReadModelPostgresRepository = CertificateReadModelPostgresRepository;
//# sourceMappingURL=CertificateReadModelPostgres.repository.js.map