import { OnChainCertificateService } from '../../../onchain-certificate/onchain-certificate.service';
import { CertificateEventRepository } from '../../repositories/CertificateEvent/CertificateEvent.repository';
import { CertificateEventEntity } from '../../repositories/CertificateEvent/CertificateEvent.entity';
import { OffChainCertificateService } from '../../offchain-certificate.service';
import { SynchronizeHandler } from './synchronize.handler';
import { BatchConfiguration } from '../strategies/batch/batch.configuration';
export declare class IssuePersistHandler implements SynchronizeHandler {
    private readonly certificateService;
    private readonly offchainCertificateService;
    private readonly certEventRepo;
    private batchConfiguration;
    constructor(certificateService: OnChainCertificateService, offchainCertificateService: OffChainCertificateService, certEventRepo: CertificateEventRepository, batchConfiguration: BatchConfiguration);
    canHandle(event: CertificateEventEntity): boolean;
    handle(event: CertificateEventEntity): Promise<{
        success: boolean;
    }>;
    synchronizeBatchBlock(events: CertificateEventEntity[]): Promise<{
        failedCertificateIds: number[];
    }>;
    handleBatch(events: CertificateEventEntity[]): Promise<{
        failedCertificateIds: number[];
    }>;
    private static isCertificateIdValid;
}
