import { SynchronizableEvent } from '../../repositories/CertificateEvent/CertificateEvent.repository';
import { ClaimPersistHandler } from './claim-persist.handler';
import { TransferPersistHandler } from './transfer-persist.handler';
import { IssuePersistHandler } from './issue-persist.handler';
export declare class SynchronizeManager {
    private readonly claimPersistHandler;
    private readonly issuancePersistHandler;
    private readonly transferPersistHandler;
    private readonly processors;
    constructor(claimPersistHandler: ClaimPersistHandler, issuancePersistHandler: IssuePersistHandler, transferPersistHandler: TransferPersistHandler);
    handle(event: SynchronizableEvent): Promise<{
        success: boolean;
    }>;
    handleBatch(events: SynchronizableEvent[]): Promise<{
        failedCertificateIds: number[];
    }>;
}
