"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SerialSynchronizeStrategy = void 0;
const common_1 = require("@nestjs/common");
const synchronize_manager_1 = require("../../handlers/synchronize.manager");
let SerialSynchronizeStrategy = class SerialSynchronizeStrategy {
    constructor(synchronizeManager) {
        this.synchronizeManager = synchronizeManager;
    }
    async synchronize(events) {
        const sortedEvents = events.sort((a, b) => a.createdAt.getTime() - b.createdAt.getTime());
        const failedCertificateIds = [];
        for (const event of sortedEvents) {
            if (failedCertificateIds.includes(event.internalCertificateId)) {
                continue;
            }
            const { success } = await this.synchronizeManager.handle(event);
            if (!success) {
                failedCertificateIds.push(event.internalCertificateId);
            }
        }
    }
};
SerialSynchronizeStrategy = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [synchronize_manager_1.SynchronizeManager])
], SerialSynchronizeStrategy);
exports.SerialSynchronizeStrategy = SerialSynchronizeStrategy;
//# sourceMappingURL=serial-synchronize.strategy.js.map