import { IGetAllCertificatesOptions } from '@energyweb/issuer-api';
import { QueryBus } from '@nestjs/cqrs';
import { Queue } from 'bull';
import { BlockchainAction, ICertificate, ISuccessResponse } from './types';
import { IClaimCommand, IIssueCommandParams, IIssuedCertificate, ITransferCommand } from '../types';
export declare class OnChainCertificateService<T = null> {
    private readonly queryBus;
    private readonly blockchainActionsQueue;
    constructor(queryBus: QueryBus, blockchainActionsQueue: Queue<BlockchainAction>);
    getAll(options?: IGetAllCertificatesOptions): Promise<ICertificate<T>[]>;
    getById(id: number): Promise<ICertificate<T> | null>;
    issue(params: IIssueCommandParams<T>): Promise<IIssuedCertificate<T>>;
    claim(command: IClaimCommand): Promise<ISuccessResponse>;
    transfer(command: ITransferCommand): Promise<ISuccessResponse>;
    batchIssue(originalCertificates: IIssueCommandParams<T>[]): Promise<number[]>;
    batchClaim(command: IClaimCommand[]): Promise<ISuccessResponse>;
    batchTransfer(command: ITransferCommand[]): Promise<ISuccessResponse>;
    private mapCertificate;
    private waitForJobResult;
}
